#ifndef __UTIL_H__
#define __UTIL_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define MSG(s) fprintf(stderr, "%s() %s L%d : %s\n", __func__, __FILE__, __LINE__, s)
#define ERR(s) do{ fprintf(stderr, "ERR "); MSG(s); exit(1); }while(0)

#define OFF		0
#define ON		1
#define BUFSZ		1024
#define AVSZ		16

#define ARR_N(arr)		( sizeof (arr) / sizeof *(arr) )
#define MIX(a, b, rate)		( (a) * (1 - (rate)) + (b) * (rate) )
#define ABS(v)			( (v) < 0 ? -(v) : (v) )
#define MAX(a, b)		( (a) > (b) ? (a) : (b) )
#define MIN(a, b)		( (a) < (b) ? (a) : (b) )

void opt_show(int ac, char **av);
int opt_idx(char *key, int ac, char **av);
char *opt_str(char *key, int ac, char **av, char *def);
int opt_int(char *key, int ac, char **av, int def);
double opt_double(char *key, int ac, char **av, double def);

void line_to_ac_av(char *line, int *ac, char **av);
char *opt_prefix(char *prev, int ac, char **av);

int opt_ch_loop_get(char **sp, int *ch, int *v);
int opt_ch_loop_get_dbl(char **sp, int *ch, double *v);


struct stklst{
	int size;
	void *p;
	struct stklst *prev;
};

struct stklst *stklst_alloc(int size, struct stklst *prev);
void stklst_allfree(struct stklst *p);
int stklst_allsize(struct stklst *p);
void *stklst_to_arr(struct stklst *p);

int dbl_max_idx(double *p, int next_bytes, int n, double *ret_v);

FILE *fp_get(char *key, int ac, char **av, char *def_fn, char *mode, char **ret_fn);


struct chatt{
	double lmt_sec, sec, chg_try_sec;
	int onoff;
};

void chatt_init(struct chatt *ct, double lmt_sec);
int chatt_add(struct chatt *ct, double sec, int onoff);
void chatt_set(struct chatt *ct, int onoff);


struct max_sum{
	double sum;
	int n;

	double max_v, min_v;
	int max_i, min_i;
};

void max_sum_init(struct max_sum *p);
void max_sum_add(struct max_sum *p, double v);
double max_sum_mean(struct max_sum *p);

#endif
